local LOG = give_initial_enderchest.log
local enable_enderchest = give_initial_enderchest.enable

---@param player mt.PlayerObjectRef
---@return nil
function give_initial_enderchest.give(player)
	give_initial_enderchest._give_common(player,
			give_initial_enderchest.targetlist, give_initial_enderchest.items)
end

---@param stack mt.ItemStack|string
---@return nil
function give_initial_enderchest.add(stack)
	table.insert(give_initial_enderchest.items, stack)
end

---@param csv string
---@return nil
function give_initial_enderchest.add_from_csv(csv)
	for _, stack in ipairs(csv:split(",")) do
		give_initial_enderchest.add(stack)
	end
end

---@return nil
function give_initial_enderchest.clear()
	give_initial_enderchest.items = {}
end

---@return (mt.ItemStack|string)[]
function give_initial_enderchest.get_list()
	return give_initial_enderchest.items
end

---@param list (mt.ItemStack|string)[]
---@return nil
function give_initial_enderchest.set_list(list)
	give_initial_enderchest.items = list
end


if not (core.get_modpath("mcl_chests") or core.get_modpath("xdecor")) then
	if not enable_enderchest then
		LOG("warning",
				"Ender chest mod not found! Using main inventory as fallback.")
	end
	give_initial_enderchest.targetlist = "main"
end

if enable_enderchest then
	local csv = core.settings:get("give_initial_enderchest_items") or ""
	give_initial_enderchest.add_from_csv(csv)
end
